require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ARM_ASM_H_)) {
    eval 'sub _ARM_ASM_H_ () {1;}' unless defined(&_ARM_ASM_H_);
    if(defined(&__ELF__)) {
	eval 'sub _C_LABEL {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&_C_LABEL);
    } else {
	if(defined(&__STDC__)) {
	    eval 'sub _C_LABEL {
	        my($x) = @_;
    		eval q( &_  $x);
	    }' unless defined(&_C_LABEL);
	} else {
	    eval 'sub _C_LABEL {
	        my($x) = @_;
    		eval q( &_ $x);
	    }' unless defined(&_C_LABEL);
	}
    }
    eval 'sub _ASM_LABEL {
        my($x) = @_;
	    eval q($x);
    }' unless defined(&_ASM_LABEL);
    if(defined(&__STDC__)) {
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q($x  $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q($x);
	}' unless defined(&__STRING);
    } else {
	eval 'sub __CONCAT {
	    my($x,$y) = @_;
    	    eval q($x $y);
	}' unless defined(&__CONCAT);
	eval 'sub __STRING {
	    my($x) = @_;
    	    eval q(\\"x\\");
	}' unless defined(&__STRING);
    }
    unless(defined(&_ALIGN_TEXT)) {
	eval 'sub _ALIGN_TEXT () {. &align 0;}' unless defined(&_ALIGN_TEXT);
    }
    eval 'sub _ASM_TYPE_FUNCTION () { &function;}' unless defined(&_ASM_TYPE_FUNCTION);
    eval 'sub _ASM_TYPE_OBJECT () { &object;}' unless defined(&_ASM_TYPE_OBJECT);
    eval 'sub _ENTRY {
        my($x) = @_;
	    eval q(. &text;  &_ALIGN_TEXT; . &globl $x; . &type $x, &_ASM_TYPE_FUNCTION; $x:);
    }' unless defined(&_ENTRY);
    if(defined(&GPROF)) {
	if(defined(&__ELF__)) {
	    eval 'sub _PROF_PROLOGUE () { &mov  &ip,  &lr;  &bl  &__mcount;}' unless defined(&_PROF_PROLOGUE);
	} else {
	    eval 'sub _PROF_PROLOGUE () { &mov  &ip, &lr;  &bl  &mcount;}' unless defined(&_PROF_PROLOGUE);
	}
    } else {
	eval 'sub _PROF_PROLOGUE () {1;}' unless defined(&_PROF_PROLOGUE);
    }
    eval 'sub ENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_C_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ENTRY);
    eval 'sub ENTRY_NP {
        my($y) = @_;
	    eval q( &_ENTRY( &_C_LABEL($y)));
    }' unless defined(&ENTRY_NP);
    eval 'sub ASENTRY {
        my($y) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($y));  &_PROF_PROLOGUE);
    }' unless defined(&ASENTRY);
    eval 'sub ASENTRY_NP {
        my($y) = @_;
	    eval q( &_ENTRY( &_ASM_LABEL($y)));
    }' unless defined(&ASENTRY_NP);
    eval 'sub ASMSTR () {. &asciz;}' unless defined(&ASMSTR);
    if(defined(&__ELF__)  && defined(&__PIC__)) {
	if(defined(&__STDC__)) {
	    eval 'sub PIC_SYM {
	        my($x,$y) = @_;
    		eval q($x  (  $y  ));
	    }' unless defined(&PIC_SYM);
	} else {
	    eval 'sub PIC_SYM {
	        my($x,$y) = @_;
    		eval q($x ( $y ));
	    }' unless defined(&PIC_SYM);
	}
    } else {
	eval 'sub PIC_SYM {
	    my($x,$y) = @_;
    	    eval q($x);
	}' unless defined(&PIC_SYM);
    }
    if(defined(&__ELF__)) {
	eval 'sub RCSID {
	    my($x) = @_;
    	    eval q(. &section \\".ident\\"; . &asciz $x);
	}' unless defined(&RCSID);
    } else {
	eval 'sub RCSID {
	    my($x) = @_;
    	    eval q(. &text; . &asciz $x);
	}' unless defined(&RCSID);
    }
    if(defined(&__ELF__)) {
	eval 'sub STRONG_ALIAS {
	    my($alias,$sym) = @_;
    	    eval q(. &global $alias; $alias = $sym);
	}' unless defined(&STRONG_ALIAS);
	eval 'sub WEAK_ALIAS {
	    my($alias,$sym) = @_;
    	    eval q(. &weak $alias; $alias = $sym);
	}' unless defined(&WEAK_ALIAS);
    }
    if(defined(&__STDC__)) {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &stabs $msg  ,30,0,0,0; . &stabs  &__STRING( &_C_LABEL($sym))  ,1,0,0,0);
	}' unless defined(&WARN_REFERENCES);
    }
 elsif(defined(&__ELF__)) {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &stabs $msg,30,0,0,0; . &stabs  &__STRING($sym),1,0,0,0);
	}' unless defined(&WARN_REFERENCES);
    } else {
	eval 'sub WARN_REFERENCES {
	    my($sym,$msg) = @_;
    	    eval q(. &stabs $msg,30,0,0,0; . &stabs  &__STRING( &_ $sym),1,0,0,0);
	}' unless defined(&WARN_REFERENCES);
    }
}
1;
