require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_ARM_PARAM_H_)) {
    eval 'sub _ARM_PARAM_H_ () {1;}' unless defined(&_ARM_PARAM_H_);
    eval 'sub MACHINE_ARCH () {"arm";}' unless defined(&MACHINE_ARCH);
    eval 'sub _MACHINE_ARCH () { &arm;}' unless defined(&_MACHINE_ARCH);
    eval 'sub MID_MACHINE () { &MID_ARM6;}' unless defined(&MID_MACHINE);
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    eval 'sub PAGE_SIZE () {(1<<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    eval 'sub PAGE_MASK () {( &PAGE_SIZE - 1);}' unless defined(&PAGE_MASK);
    if(defined(&_KERNEL)) {
	eval 'sub NPTEPG () {( &PAGE_SIZE/($sizeof{ &pt_entry_t}));}' unless defined(&NPTEPG);
	eval 'sub NBPG () { &PAGE_SIZE;}' unless defined(&NBPG);
	eval 'sub PGSHIFT () { &PAGE_SHIFT;}' unless defined(&PGSHIFT);
	eval 'sub PGOFSET () { &PAGE_MASK;}' unless defined(&PGOFSET);
	eval 'sub UPAGES () {2;}' unless defined(&UPAGES);
	eval 'sub USPACE () {( &UPAGES *  &PAGE_SIZE);}' unless defined(&USPACE);
	eval 'sub USPACE_ALIGN () {0;}' unless defined(&USPACE_ALIGN);
	eval 'sub NMBCLUSTERS () {4096;}' unless defined(&NMBCLUSTERS);
	unless(defined(&MSGBUFSIZE)) {
	    eval 'sub MSGBUFSIZE () {(1*  &PAGE_SIZE);}' unless defined(&MSGBUFSIZE);
	}
	eval 'sub NKMEMPAGES_MAX_DEFAULT () {((64* 1024* 1024) >>  &PAGE_SHIFT);}' unless defined(&NKMEMPAGES_MAX_DEFAULT);
	eval 'sub FPCONTEXTSIZE () {(0x100);}' unless defined(&FPCONTEXTSIZE);
	eval 'sub USPACE_SVC_STACK_TOP () {( &USPACE);}' unless defined(&USPACE_SVC_STACK_TOP);
	eval 'sub USPACE_SVC_STACK_BOTTOM () {( &USPACE_SVC_STACK_TOP - 0x1000);}' unless defined(&USPACE_SVC_STACK_BOTTOM);
	eval 'sub USPACE_UNDEF_STACK_TOP () {( &USPACE_SVC_STACK_BOTTOM - 0x10);}' unless defined(&USPACE_UNDEF_STACK_TOP);
	eval 'sub USPACE_UNDEF_STACK_BOTTOM () {($sizeof{\'struct user\'} +  &FPCONTEXTSIZE + 10);}' unless defined(&USPACE_UNDEF_STACK_BOTTOM);
	unless(defined(&_LOCORE)) {
	    eval 'sub DELAY {
	        my($x) = @_;
    		eval q( &delay($x));
	    }' unless defined(&DELAY);
	}
	if(!defined(&_LOCORE)) {
	    require 'machine/cpu.ph';
	}
	eval 'sub STACKALIGNBYTES () {(8- 1);}' unless defined(&STACKALIGNBYTES);
	eval 'sub STACKALIGN {
	    my($p) = @_;
    	    eval q((($p) &~  &STACKALIGNBYTES));
	}' unless defined(&STACKALIGN);
    }
}
1;
