require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MACHINE_INTR_H_)) {
    eval 'sub _MACHINE_INTR_H_ () {1;}' unless defined(&_MACHINE_INTR_H_);
    if(defined(&_KERNEL)) {
	eval 'sub IPL_NONE () {0;}' unless defined(&IPL_NONE);
	eval 'sub IPL_SOFT () {1;}' unless defined(&IPL_SOFT);
	eval 'sub IPL_SOFTCLOCK () {2;}' unless defined(&IPL_SOFTCLOCK);
	eval 'sub IPL_SOFTNET () {3;}' unless defined(&IPL_SOFTNET);
	eval 'sub IPL_SOFTTTY () {4;}' unless defined(&IPL_SOFTTTY);
	eval 'sub IPL_BIO () {5;}' unless defined(&IPL_BIO);
	eval 'sub IPL_NET () {6;}' unless defined(&IPL_NET);
	eval 'sub IPL_TTY () {7;}' unless defined(&IPL_TTY);
	eval 'sub IPL_VM () {8;}' unless defined(&IPL_VM);
	eval 'sub IPL_AUDIO () {9;}' unless defined(&IPL_AUDIO);
	eval 'sub IPL_CLOCK () {10;}' unless defined(&IPL_CLOCK);
	eval 'sub IPL_STATCLOCK () {11;}' unless defined(&IPL_STATCLOCK);
	eval 'sub IPL_SCHED () {12;}' unless defined(&IPL_SCHED);
	eval 'sub IPL_HIGH () {12;}' unless defined(&IPL_HIGH);
	eval 'sub NIPL () {13;}' unless defined(&NIPL);
	eval 'sub IPL_MPSAFE () {0;}' unless defined(&IPL_MPSAFE);
	eval 'sub IST_NONE () {0;}' unless defined(&IST_NONE);
	eval 'sub IST_PULSE () {1;}' unless defined(&IST_PULSE);
	eval 'sub IST_EDGE () {2;}' unless defined(&IST_EDGE);
	eval 'sub IST_LEVEL () {3;}' unless defined(&IST_LEVEL);
	eval 'sub IST_LEVEL_LOW () { &IST_LEVEL;}' unless defined(&IST_LEVEL_LOW);
	eval 'sub IST_LEVEL_HIGH () {4;}' unless defined(&IST_LEVEL_HIGH);
	eval 'sub IST_EDGE_FALLING () { &IST_EDGE;}' unless defined(&IST_EDGE_FALLING);
	eval 'sub IST_EDGE_RISING () {5;}' unless defined(&IST_EDGE_RISING);
	eval 'sub IST_EDGE_BOTH () {6;}' unless defined(&IST_EDGE_BOTH);
	unless(defined(&_LOCORE)) {
	    require 'sys/device.ph';
	    require 'sys/queue.ph';
	    eval 'sub splraise {
	        my($cpl) = @_;
    		eval q(( ($arm_intr_func->{raise})($cpl)));
	    }' unless defined(&splraise);
	    eval 'sub _splraise {
	        my($cpl) = @_;
    		eval q(( ($arm_intr_func->{raise})($cpl)));
	    }' unless defined(&_splraise);
	    eval 'sub spllower {
	        my($cpl) = @_;
    		eval q(( ($arm_intr_func->{lower})($cpl)));
	    }' unless defined(&spllower);
	    eval 'sub splx {
	        my($cpl) = @_;
    		eval q(( ($arm_intr_func->{x})($cpl)));
	    }' unless defined(&splx);
	    eval 'sub splhigh () {
	        eval q( &splraise( &IPL_HIGH));
	    }' unless defined(&splhigh);
	    eval 'sub splsoft () {
	        eval q( &splraise( &IPL_SOFT));
	    }' unless defined(&splsoft);
	    eval 'sub splsoftclock () {
	        eval q( &splraise( &IPL_SOFTCLOCK));
	    }' unless defined(&splsoftclock);
	    eval 'sub splsoftnet () {
	        eval q( &splraise( &IPL_SOFTNET));
	    }' unless defined(&splsoftnet);
	    eval 'sub splbio () {
	        eval q( &splraise( &IPL_BIO));
	    }' unless defined(&splbio);
	    eval 'sub splnet () {
	        eval q( &splraise( &IPL_NET));
	    }' unless defined(&splnet);
	    eval 'sub spltty () {
	        eval q( &splraise( &IPL_TTY));
	    }' unless defined(&spltty);
	    eval 'sub splvm () {
	        eval q( &splraise( &IPL_VM));
	    }' unless defined(&splvm);
	    eval 'sub splaudio () {
	        eval q( &splraise( &IPL_AUDIO));
	    }' unless defined(&splaudio);
	    eval 'sub splclock () {
	        eval q( &splraise( &IPL_CLOCK));
	    }' unless defined(&splclock);
	    eval 'sub splstatclock () {
	        eval q( &splraise( &IPL_STATCLOCK));
	    }' unless defined(&splstatclock);
	    eval 'sub spl0 () {
	        eval q( &spllower( &IPL_NONE));
	    }' unless defined(&spl0);
	    eval 'sub splsched () {
	        eval q( &splhigh());
	    }' unless defined(&splsched);
	    eval 'sub spllock () {
	        eval q( &splhigh());
	    }' unless defined(&spllock);
	    eval 'sub _setsoftintr () { &arm_setsoftintr;}' unless defined(&_setsoftintr);
	    require 'arm/softintr.ph';
	    if(defined(&DIAGNOSTIC)) {
		eval 'sub splassert {
		    my($__wantipl) = @_;
    		    eval q( &do {  &if ( &splassert_ctl > 0) {  &arm_splassert_check($__wantipl,  &__func__); } }  &while (0));
		}' unless defined(&splassert);
		eval 'sub splsoftassert {
		    my($wantipl) = @_;
    		    eval q( &splassert($wantipl));
		}' unless defined(&splsoftassert);
	    } else {
		eval 'sub splassert {
		    my($wantipl) = @_;
    		    eval q( &do { }  &while (0));
		}' unless defined(&splassert);
		eval 'sub splsoftassert {
		    my($wantipl) = @_;
    		    eval q( &do { }  &while (0));
		}' unless defined(&splsoftassert);
	    }
	}
	eval 'sub ARM_IRQ_HANDLER () { &arm_intr;}' unless defined(&ARM_IRQ_HANDLER);
    }
}
1;
